/*
 *
 *  Copyright (C) 1999 Peter Amstutz
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of *the
 *  License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307 USA
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.util.*;

public class CollisionBehavior extends Behavior {
    Node collidewith;
    WakeupCondition wakeyWakey;
    MovementBehavior grav;

    CollisionBehavior(Node n, MovementBehavior g) {
        collidewith=n;
        grav=g;
    }

    public void initialize() {
        WakeupCriterion[] wc=new WakeupCriterion[2];

        wc[0]=new WakeupOnCollisionEntry(collidewith, WakeupOnCollisionEntry.USE_GEOMETRY);
        wc[1]=new WakeupOnCollisionExit(collidewith, WakeupOnCollisionEntry.USE_GEOMETRY);
        //wc[2]=new WakeupOnCollisionMovement(collidewith, WakeupOnCollisionEntry.USE_BOUNDS);
        wakeyWakey=new WakeupOr(wc);
        wakeupOn(wakeyWakey);
        //wakeupOn(new WakeupOnCollisionEntry(collidewith, WakeupOnCollisionEntry.USE_BOUNDS));
    }

    public void processStimulus(Enumeration criteria) {
        System.out.println("Collision!!!");
        while(criteria.hasMoreElements()) {
            Object ob=criteria.nextElement();
            System.out.println("* "+ob);
            System.out.println("Path!!!");
            SceneGraphPath sgp=null;
            if(ob instanceof WakeupOnCollisionEntry) {
                sgp=((WakeupOnCollisionEntry)ob).getTriggeringPath();
                grav.setMoving(false);
                grav.setEnable(false);
            }
            if(ob instanceof WakeupOnCollisionExit) {
                sgp=((WakeupOnCollisionExit)ob).getTriggeringPath();
                grav.startMovement(new Vector3d(0.0, .03, 0.0), 50);
                grav.setEnable(true);
                grav.setMoving(true);
            }
            for(int i=0; i<sgp.nodeCount(); i++) {
                System.out.println(sgp.getNode(i));
            }
        }
        wakeupOn(wakeyWakey);
        //woce=new WakeupOnCollisionEntry(collidewith, WakeupOnCollisionEntry.USE_GEOMETRY);
        //wakeupOn(woce);
        //wakeupOn(new WakeupOnCollisionEntry(collidewith, WakeupOnCollisionEntry.USE_BOUNDS));
    }
}
